#include<iostream>
#include<vector>
#include<queue>
using namespace std;
int n, m, board[400000];
vector<int> adj_list[400001];
bool visited[400001];
void input(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> m;
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            cin >> board[y * m + x];
            visited[y * m + x] = false;
        }
    }
}
void build_adj_list(){
    for(int y = 0; y < n; ++y){
        for(int x = 0; x < m; ++x){
            if(0 <= (y + 1) * m + x && (y + 1) * m + x < n * m){
                adj_list[board[y * m + x]].push_back(board[(y + 1) * m + x]);
            }
            if(0 <= (y - 1) * m + x && (y - 1) * m + x < n * m){
                adj_list[board[y * m + x]].push_back(board[(y - 1) * m + x]);
            }
            if(0 <= y * m + x + 1 && y * m + x + 1 < n * m && x + 1 < m){
                adj_list[board[y * m + x]].push_back(board[y * m + x + 1]);
            }
            if(0 <= y * m + x - 1 && y * m + x - 1 < n * m && x - 1 >= 0){
                adj_list[board[y * m + x]].push_back(board[y * m + x - 1]);
            }
        }
    }
}

bool is_solvable(){
    int next = 1;
    priority_queue<int, std::vector<int>, std::greater<int> > pq;
    pq.push(1);
    while(!pq.empty()){
        int top = pq.top();
        visited[top] = true;
        pq.pop();
        if(top == next){
            for(auto neighbour : adj_list[top]){
                if(!visited[neighbour]){
                    pq.push(neighbour);
                    visited[neighbour] = true;
                }
            }
            next++;
        }
    }
    return next == 1 + n * m;
}
int main(){
    input();
    build_adj_list();
    if(is_solvable()){
        cout << 0;
    }else{
        cout << 2;
    }
    return 0;
}
/*
3 3
2 1 3 6 7 4 9 8 5
*/
