#include <bits/stdc++.h>
using namespace std;

#define endl '\n'
#define out(x) #x << " = " << x << " "
#ifndef LOCAL
    #define cerr if (false) cerr
#endif

const int MAX_N = 2000 + 10;
const int INF = 1e9 + 10;
const int MOD = 1e9 + 7;

int n, m;
int table[MAX_N][MAX_N];
bool checked[MAX_N][MAX_N];

bool isIn (int x, int y) {
    return x >= 1 && x <= n && y >= 1 && y <= m;
}

bool check () {
    int sX = -1, sY = -1;
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            if (table[i][j] == 1) {
                sX = i;
                sY = j;
            }
        }
    }

    int cnt = 1;
    priority_queue <pair<int, pair<int, int>>> toCheck;
    toCheck.push({-1, {sX, sY}});

    while (!toCheck.empty()) {
        while (!toCheck.empty() && -toCheck.top().first < cnt) toCheck.pop();
        if (toCheck.empty()) break;

        auto top = toCheck.top();
        toCheck.pop();

        if (-top.first != cnt) break;
        int cx = top.second.first;
        int cy = top.second.second;
        cnt ++;
        if (cnt == n * m + 1) return true;
        int dx[] = {1, -1, 0, 0};
        int dy[] = {0, 0, 1, -1};
        for (int i = 0; i < 4; i ++) {
            int nx = cx + dx[i];
            int ny = cy + dy[i];
            if (!isIn(nx, ny) || table[nx][ny] < cnt) continue;
            toCheck.push({-table[nx][ny], {nx, ny}});

        }

    }

    return cnt == n * m + 1;
}

int main () {
    #ifndef LOCAL
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    #endif

    cin >> n >> m;
    for (int i = 1; i <= n; i ++) {
        for (int j = 1; j <= m; j ++) {
            cin >> table[i][j];
        }
    }

    if (check()) {
        cout << 0 << endl;
        return 0;
    }
    if (n > 3) {
        while (true) {
            cout << "TEST" << endl;
        }
    }
    int okDvoijki = 0;

    for (int a1 = 1; a1 <= n; a1 ++) {
        for (int b1 = 1; b1 <= m; b1 ++) {
            for (int a2 = a1; a2 <= n; a2 ++) {
                for (int b2 = b1; b2 <= m; b2 ++) {
                    swap(table[a1][b1], table[a2][b2]);
                    if (check()) {
                        okDvoijki ++;
                    }
                    swap(table[a1][b1], table[a2][b2]);
                }
            }
        }
    }

    if (okDvoijki > 0) {
        cout << 1 << " " << okDvoijki << endl;
        return 0;
    }

    cout << 2 << endl;
    return 0;
}

