# include <iostream>
# include <vector>
# include <queue>
using namespace std;

const int MAX=4e5+11;
int adj[4][2]={{0,1},{1,0},{-1,0},{0,-1}};
vector<vector<int>> a;
pair<int, int> pos[MAX];
bool vis[MAX];
int n,m;

int check()
{
    for(int i=1;i<=n*m;i++) vis[i]=0;

    vis[1]=1;
    for(int i=1;i<=n*m;i++)
    {
        if(!vis[i]) return i-1;

        for(int k=0;k<4;k++)
        {
            int x=pos[i].first+adj[k][0];
            int y=pos[i].second+adj[k][1];

            if(1<=x and x<=n and 1<=y and y<=m) vis[a[x][y]]=1;
        }
    }

    return n*m;
}

bool Swap(pair<int, int> p, pair<int, int> q)
{
    swap(a[p.first][p.second],a[q.first][q.second]);
    pos[a[p.first][p.second]]=p;
    pos[a[q.first][q.second]]=q;

    bool f=(check()==n*m);

    swap(a[p.first][p.second],a[q.first][q.second]);
    pos[a[p.first][p.second]]=p;
    pos[a[q.first][q.second]]=q;

    return f;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    cin>>n>>m;
    a.resize(n+2);
    for(int i=1;i<=n;i++)
    {
        a[i].resize(m+2);
        for(int j=1;j<=m;j++)
        {
            cin>>a[i][j];
            pos[a[i][j]]={i,j};
        }
    }

    int to=check();
    if(to==n*m)
    {
        cout<<0<<"\n";
        return 0;
    }

    //cout<<to<<"\n";

    int best_ans=2;
    int ans=0;
    for(int i=1;i<=n;i++)
    {
        for(int j=1;j<=m;j++)
        {
            if(!(pos[to+1].first==i and pos[to+1].second==j) and Swap(pos[1],{i,j}))
            {
                if(best_ans==2)
                {
                    best_ans=1;
                    ans=1;
                }
                else ans++;
            }

            if(Swap(pos[to+1],{i,j}))
            {
                if(best_ans==2)
                {
                    best_ans=1;
                    ans=1;
                }
                else ans++;
            }
        }
    }

    if(best_ans==2) cout<<2<<"\n";
    else cout<<best_ans<<" "<<ans<<"\n";

    return 0;
}

