#include <bits/stdc++.h>
#define llong int
using namespace std;

struct Node
{
    llong LNode;
    llong RNode;
    llong Answer;
};

const llong MAXN = 5 * 1e5 + 1;
const llong MAXVALUE = 2 * 1e3 + 1;
llong N, Q;
llong A[MAXN];
llong Precalc[MAXN][MAXN];
Node Tree[4 * MAXN];
bool Prime[MAXVALUE];
vector<llong> Primes;
llong PrimeDivs[MAXVALUE];
bool Visited[MAXVALUE];

void Sieve()
{
    Prime[0] = true;
    Prime[1] = true;


    for(llong i = 2; i * i < MAXVALUE; i++)
    {
        if(Prime[i])
        {
            continue;
        }

        for(llong j = i * i; j < MAXVALUE; j += i)
        {
            Prime[j] = true;
        }
    }

    for(llong i = 1; i < MAXVALUE; i++)
    {
        if(Prime[i])
        {
            continue;
        }

        Primes.push_back(i);
    }
}

void Calc(llong Value)
{
    llong X = Value;

    for(llong i = 0; i < (llong)Primes.size() && Prime[i] * Prime[i] <= Value; i++)
    {
        while(Value % Primes[i] == 0)
        {
            PrimeDivs[X]++;
            Value /= Primes[i];
        }
    }

    if(Value != 1)
    {
        PrimeDivs[X]++;
    }
}

void Find_Divs()
{
    for(llong i = 1; i < MAXVALUE; i++)
    {
        Calc(i);
    }
}

void Merge(llong Root)
{
    Tree[Root].Answer = Tree[2 * Root].Answer + Tree[2 * Root + 1].Answer;
    Tree[Root].LNode = Tree[2 * Root].LNode;
    Tree[Root].RNode = Tree[2 * Root + 1].RNode;

    llong gcd = __gcd(Tree[2 * Root].RNode, Tree[2 * Root + 1].LNode);

    if(!Visited[gcd])
    {
        Calc(gcd);
        Visited[gcd] = true;
    }

    Tree[Root].Answer -= PrimeDivs[gcd];
}

void Build(llong Root, llong Tl, llong Tr)
{
    if(Tl == Tr)
    {
        if(!Visited[A[Tl]])
        {
            Calc(A[Tl]);
            Visited[A[Tl]] = true;
        }

        Tree[Root] = {A[Tl], A[Tl], PrimeDivs[A[Tl]]};
        return;
    }

    llong Mid = (Tl + Tr) / 2;
    Build(2 * Root, Tl, Mid);
    Build(2 * Root + 1, Mid + 1, Tr);
    Merge(Root);
}

void Update(llong Root, llong Tl, llong Tr, llong Index, llong Value)
{
    if(Tr < Index || Tl > Index)
    {
        return;
    }

    if(Tl == Tr && Tl == Index)
    {
        if(!Visited[Value])
        {
            Calc(Value);
            Visited[Value] = true;
        }

        Tree[Root] = {Value, Value, PrimeDivs[Value]};
        return;
    }

    int Mid = (Tl + Tr) / 2;
    Update(2 * Root, Tl, Mid, Index, Value);
    Update(2 * Root + 1, Mid + 1, Tr, Index, Value);
    Merge(Root);
}

void Upgrade_Speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void Read()
{
    cin >> N >> Q;

    for(llong i = 0; i < N; i++)
    {
        cin >> A[i];
    }
}

void Solve()
{
    Build(1, 0, N - 1);
    cout << Tree[1].Answer << '\n';

    while(Q--)
    {
        llong Index, Value;
        cin >> Index >> Value;
        Update(1, 0, N - 1, Index - 1, Value);
        cout << Tree[1].Answer << '\n';
    }
}

int main()
{
    Upgrade_Speed();
    Sieve();
    ///Find_Divs();
    Read();
    Solve();
    return 0;
}
