#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const ll MAXN = 5e5 + 10;
const ll MAXQ = 5e5 + 10;
const ll MAXA = 2e6 + 10;
const ll INF = 4e18 + 10;

ll n, q;
vector < ll > a;
map < vector < ll >, ll > dp;
ll lpd[MAXA];

void read()
{
    cin >> n >> q;
    a.resize(n + 1);
    for(ll i = 1; i <= n; i++)
    {
        cin >> a[i];
    }
}

void sieve()
{
    for(int i = 2; i < MAXA; i++)
    {
        if(lpd[i])
            continue;

        for(int j = i; j < MAXA; j += i)
        {
            if(!lpd[j])
            {
                lpd[j] = i;
            }
        }
    }
}

ll gcd(ll a, ll b)
{
    return !b ? a : gcd(b, a % b);
}

ll find_cnt(ll x)
{
    ll cnt = 0;

    while(x > 1)
    {
        ll l = lpd[x];
        x /= l;
        cnt++;
    }

    return cnt;
}

ll solve(vector < ll > red)
{

    if(dp.find(red) != dp.end())
        return dp[red];

    bool lampa = true;
    for(int i = 1; i <= n; i++)
    {
        if(red[i] != 1)
        {
            lampa = false;
            break;
        }
    }
    if(lampa)
        return 0LL;

    ll result = INF;
    for(int i = 1; i <= n; i++)
    {
        if(red[i] == 1)
            continue;

        ll g = red[i];

        for(int j = i; j <= n; j++)
        {
            if(gcd(g, red[j]) == 1)
                break;

            g = gcd(g, red[j]);

            for(int k = i; k <= j; k++)
            {
                assert(red[k] % g == 0);
                red[k] /= g;
            }

            result = min(result, find_cnt(g) + solve(red));

            for(int k = i; k <= j; k++)
            {
                red[k] *= g;
            }
        }
    }

    return dp[red] = result;
}

void process_queries()
{
    cout << solve(a) << endl;
    for(int i = 1; i <= q; i++)
    {
        ll pos, val;
        cin >> pos >> val;
        a[pos] = val;
        cout << solve(a) << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    sieve();
    process_queries();

    return 0;
}
