#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

struct cell
{
    int x, y;
    cell()
    {
        x = y = 0;
    }
    cell(int _x, int _y)
    {
        x = _x;
        y = _y;
    }

    friend cell operator+(cell c1, cell c2)
    {
        cell result;

        result.x = c1.x + c2.x;
        result.y = c1.y + c2.y;

        return result;
    }
};

int n, m;
vector < vector < int > > a;
vector < cell > place;

cell dir[4] = {
{0, 1},
{1, 0},
{-1, 0},
{0, -1}
};

void read()
{
    cin >> n >> m;
    a.resize(n + 1);
    place.resize(n * m + 1);
    for(int i = 1; i <= n; i++)
    {
        a[i].resize(m + 1);
        for(int j = 1; j <= m; j++)
        {
            cin >> a[i][j];
            if(a[i][j] == 1)
                place[1] = cell(i, j);
        }
    }
}

bool inside(cell c)
{
    return 1 <= c.x && c.x <= n && 1 <= c.y && c.y <= m;
}

void mark(cell c)
{
    for(int i = 0; i < 4; i++)
    {
        cell nb = c + dir[i];

        if(!inside(nb))
            continue;

        int val = a[nb.x][nb.y];
        place[val] = nb;
    }
}

bool check()
{
    for(int i = 1; i <= n * m; i++)
    {
        if(place[i].x != 0)
            mark(place[i]);
        else
            return false;
    }

    return true;
}

void solve()
{
    if(check())
    {
        cout << 0 << endl;
        exit(0);
    }

    int ways = 0;

    for(int i1 = 1; i1 <= n; i1++)
    {
        for(int j1 = 1; j1 <= m; j1++)
        {
            for(int i2 = 1; i2 <= n; i2++)
            {
                for(int j2 = 1; j2 <= m; j2++)
                {
                    if(i1 == i2 && j1 == j2)
                        continue;

                   /// cout << "Current swap : " << a[i1][j1] << "-" << a[i2][j2] << endl;
                  ///  cout << endl;

                    cell c = place[1];

                    for(int i = 1; i <= n * m; i++)
                    {
                        place[i] = cell();
                    }

                    if(a[i1][j1] == 1)
                    {
                        place[1] = cell(i2, j2);
                    }
                    else if(a[i2][j2] == 1)
                    {
                        place[1] = cell(i1, j1);
                    }
                    else
                    {
                        place[1] = c;
                    }

                    swap(a[i1][j1], a[i2][j2]);

                    if(check())
                    {
                        ///cout << "Correct swap : " << endl;
                        ///cout << a[i1][j1] << "-" << a[i2][j2] << endl;
                        ways++;
                    }

                    swap(a[i1][j1], a[i2][j2]);

                    if(a[i1][j1] == 1)
                    {
                        place[1] = cell(i1, j1);
                    }
                    else if(a[i2][j2] == 1)
                    {
                        place[1] = cell(i2, j2);
                    }
                    else
                    {
                        place[1] = c;
                    }
                }
            }
        }
    }

    if(ways)
    {
        cout << 1 << " " << ways / 2<< endl;
    }
    else
    {
        cout << 2 << endl;
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}
